/*
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

#pragma once

#include "DataProvider.h"
#include "Day.h"
#include <string>
#include <vector>

namespace mirai
{

class Task;

class Event
{

  public:
	Event(DataProvider *data, EventData eventData) : data_(data), eventData_(eventData) {};

	std::string title() const;
	Time startsAt() const;
	Time endsAt() const;

	std::vector<Task> queryTasks() const;

	void setTitle(const std::string &newTitle);
	void setDay(const Day &day);
	void setStartTime(const Time &time);
	void setEndTime(const Time &time);

	int id() const;
	int sourceId() const;

  private:
	EventData eventData_;
	DataProvider *data_;
};

} // namespace mirai
